/* Edtaprg.prg
 * Additional functions to the EDTA library, version 1.1.
 * Compile with /A/L/M
 * Copyright Arno Tolmeijer, (C) 1994-1995
 */


//************
FUNCTION HexIsGTE( h1, h2 )
RETURN HexIsGT( h1, h2 ) .OR. HexIsEq( h1, h2 )


//************
FUNCTION HexIsST( h1, h2 )
RETURN !( HexIsGT( h1, h2 ) .OR. HexIsEq( h1, h2 ) )


//************
FUNCTION HexIsSTE( h1, h2 )
RETURN !HexIsGT( h1, h2 ) .OR. HexIsEq( h1, h2 )


// Compatibility functions with EDTA 1.0:

//************
FUNCTION HexNot( h1 )
RETURN Hex( BmpNot( Hex( h1 ) ) )


//************
FUNCTION HexAnd( h1, h2 )
RETURN Hex( BmpAnd( h1, h2 ) )


//************
FUNCTION HexOr( h1, h2 )
LOCAL hResult

IF VALTYPE( h1 ) == "C" .AND. VALTYPE( h2 ) == "C"
	h1 := Hex( h1 )
	h2 := Hex( h2 )

	IF LEN( h1 ) >= LEN( h2 )
		hResult := Hex( BmpOr( h1, h2 ) )
	ELSE
		hResult := Hex( BmpOr( h2, h1 ) )
	ENDIF

ELSE
	hResult := "0"

ENDIF

RETURN hResult


//************
FUNCTION HexXor( h1, h2 )
LOCAL hResult

IF VALTYPE( h1 ) == "C" .AND. VALTYPE( h2 ) == "C"
	h1 := Hex( h1 )
	h2 := Hex( h2 )

	IF LEN( h1 ) >= LEN( h2 )
		hResult := Hex( BmpXor( h1, h2 ) )
	ELSE
		hResult := Hex( BmpXor( h2, h1 ) )
	ENDIF

ELSE
	hResult := "0"

ENDIF

RETURN hResult


//************
FUNCTION HexShl( h1, xCount )
RETURN Hex( BmpShl( h1, xCount ) )


//************
FUNCTION HexShr( h1, xCount )
RETURN Hex( BmpShr( h1, xCount ) )


//************
FUNCTION HexAllIn( h1, h2 )
RETURN BmpAllIn( h1, h2 )


//************
FUNCTION HexSomeIn( h1, h2 )
RETURN BmpSomeIn( h1, h2 )
