/* Examples.prg
 * Sample code to use for checking the examples of the documentation file
 * belonging to the EDTA library.
 * Copyright Arno Tolmeijer, (C) 1994.
 * Compile: /w
 */


LOCAL nKey := 1

WHILE nKey <> 0
	CLS
	?  "1. Conversion"
	?  "2. Hex query"
	?  "3. Hex operations"
	?  "4. Bmp operations"
	?  "5. Numeric query"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		Conversion()
	CASE nKey == 2
		HexQuery()
	CASE nKey == 3
		HexOperat()
	CASE nKey == 4
		BmpOperat()
	CASE nKey == 5
		NumQuery()
	ENDCASE
END

PROCEDURE Conversion
LOCAL nKey := 1

WHILE nKey <> 0 
	CLS
	? "1. C2Hex"
	? "2. C2Bmp"
	? "3. C2N"
	? "4. Hex2C"
	? "5. Hex2N"
	? "6. N2C"
	? "7. N2Hex"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		DoC2Hex()
	CASE nKey == 2
		DoC2Bmp()
	CASE nKey == 3
		DoC2N()
	CASE nKey == 4
		DoHex2C()
	CASE nKey == 5
		DoHex2N()
	CASE nKey == 6
		DoN2C()
	CASE nKey == 7
		DoN2Hex()
	ENDCASE
END

RETURN

PROCEDURE DoC2Hex
LOCAL cValue, hValue
? 'cValue := Chr(0)+Chr(237)+"A"'
? 'hValue := C2Hex(cValue) // hValue is "ED41"'
cValue := Chr(0)+Chr(237)+"A"
hValue := C2Hex(cValue) // hValue is "ED41"
? hValue
INKEY(0)
RETURN

PROCEDURE DoC2Bmp
LOCAL cValue, hValue
? 'cValue := Chr(0)+Chr(237)+"A"'
? 'hValue := C2Bmp(cValue) // hValue is "00ED41"'
cValue := Chr(0)+Chr(237)+"A"
hValue := C2Bmp(cValue) // hValue is "00ED41"
? hValue
INKEY(0)
RETURN

PROCEDURE DoC2N
LOCAL cValue, nValue
? 'cValue := Chr(0)+Chr(0)+Chr(237)+"A"'
? 'nValue := C2N(cValue)   // nValue is "ED41" ='
? '                        // 14 * 4096 + 13 * 256 + 4 * 16 + 1 = 60737'
cValue := Chr(0)+Chr(0)+Chr(237)+"A"
nValue := C2N(cValue)
? nValue
INKEY(0)
RETURN

PROCEDURE DoHex2C
LOCAL hValue, cValue
? 'hValue := "000ED41  "'
? 'cValue := Hex2C(hValue) // cValue is Chr(237)+"A"'
hValue := "000ED41  "
cValue := Hex2C(hValue) // cValue is Chr(237)+"A"
? cValue
INKEY(0)
RETURN

PROCEDURE DoHex2N
LOCAL hValue, nValue
? 'hValue := "000ED41  "'
? 'nValue := Hex2N(hValue) // nValue is 60737'
hValue := "000ED41  "
nValue := Hex2N(hValue) // nValue is 60737
? nValue
INKEY(0)
RETURN

PROCEDURE DoN2C
LOCAL nValue, cValue
? 'nValue := 60737'
? 'cValue := N2C(nValue)   // cValue is Chr(237)+"A"'
nValue := 60737
cValue := N2C(nValue)   // cValue is Chr(237)+"A"
? cValue
INKEY(0)
RETURN

PROCEDURE DoN2Hex
LOCAL nValue, hValue
? 'nValue := 60737'
? 'hValue := N2Hex(nValue) // hValue is "ED41"'
nValue := 60737
hValue := N2Hex(nValue) // hValue is "ED41"
? hValue
INKEY(0)
RETURN

//----------------------------
// Hexadecimal query functions
//----------------------------

PROCEDURE HexQuery
LOCAL nKey := 1

WHILE nKey <> 0 
	CLS
	? "1. HexIsEq"
	? "2. HexIsGT"
	? "3. HexIsGTE"
	? "4. HexIsST"
	? "5. HexIsSTE"
	? "6. BmpAllIn"
	? "7. BmpSomeIn"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		DoHexIsEq()
	CASE nKey == 2
		DoHexIsGT()
	CASE nKey == 3
		DoHexIsGTE()
	CASE nKey == 4
		DoHexIsST()
	CASE nKey == 5
		DoHexIsSTE()
	CASE nKey == 6
		DoBmpAllIn()
	CASE nKey == 7
		DoBmpSomeIn()
	ENDCASE
END

RETURN

//---------
PROCEDURE DoHexIsEq
? 'HexIsEq( "Good Hexample", "Bad example" ) // HexIsEq( "DEAE", "BADEAE" )'
? '                                          //                      -> .F.'
? HexIsEq( "Good Hexample", "Bad example" )
? 'HexIsEq( "000 Hexample2", " example2" )   // HexIsEq( "EAE2", "EAE2" )'
? '                                          //                    -> .T.'
? HexIsEq( "000 Hexample2", " example2" )
INKEY(0)
RETURN 

PROCEDURE DoHexIsGT
? 'HexIsGT( "a123", "Bad example" ) // HexIsGT( "A123", "BADEAE" )'
? '                                 //                      -> .F.'
? HexIsGT( "a123", "Bad example" )
? 'HexIsGT( "000 Hexample2", " example2" )   // HexIsGT( "EAE2", "EAE2" )'
? '                                          //                    -> .F.'
? HexIsGT( "000 Hexample2", " example2" )
? 'HexIsGT( "10005", "10004" )      // Result is .T.'
? HexIsGT( "10005", "10004" )
INKEY(0)
RETURN 

PROCEDURE DoHexIsGTE
? 'HexIsGTE( "a123", "Bad example" ) // HexIsGTE( "A123", "BADEAE" )'
? '                                  //                       -> .F.'
? HexIsGTE( "a123", "Bad example" )
? 'HexIsGTE( "000 Hexample2", " example2" )   // HexIsGTE( "EAE2", "EAE2" )'
? '                                           //                     -> .T.'
? HexIsGTE( "000 Hexample2", " example2" )
? 'HexIsGTE( "10005", "10004" )      // Result is .T.'
? HexIsGTE( "10005", "10004" )
INKEY(0)
RETURN 

PROCEDURE DoHexIsST
? 'IsST( "a123", "Good example" ) // HexIsST( "A123", "DEAE" )'          
? '                               //                    -> .T.'
? HexIsST( "a123", "Good example" )
? 'HexIsST( "000 Hexample2", " example2" )   // HexIsST( "EAE2", "EAE2" )'
? '                                          //                    -> .F.'
? HexIsST( "000 Hexample2", " example2" )
? 'HexIsST( "10005", "10004" )       // Result is .F.'
? HexIsST( "10005", "10004" )
INKEY(0)
RETURN

PROCEDURE DoHexIsSTE
? 'HexIsSTE( "a123", "Good example" ) // HexIsSTE( "A123", "DEAE" )'
? '                                   //                     -> .T.'
? HexIsSTE( "a123", "Good example" )
? 'HexIsSTE( "000 Hexample2", " example2" )   // HexIsSTE( "EAE2", "EAE2" )'
? '                                           //                     -> .T.'
? HexIsSTE( "000 Hexample2", " example2" )
? 'HexIsSTE( "10005", "10004" )       // Result is .F.'
? HexIsSTE( "10005", "10004" )
INKEY(0)
RETURN

PROCEDURE DoBmpAllIn
? 'BmpAllIn( "4", "8" ) // Result is .F.: 0010 & 0100 -> 0000'
? BmpAllIn( "4", "8" )
? 'BmpAllIn( "4", "7" ) // Result is .F.: 0010 & 0111 -> 0010'
? BmpAllIn( "4", "7" )
? 'BmpAllIn( "7", "4" ) // Result is .T.: 0111 & 0010 -> 0010'
? BmpAllIn( "7", "4" )
INKEY(0)
RETURN

PROCEDURE DoBmpSomeIn
? 'BmpSomeIn( "4", "8" ) // Result is .F.: 0010 & 0100 -> 0000'
? BmpSomeIn( "4", "8" )
? 'BmpSomeIn( "4", "7" ) // Result is .T.: 0010 & 0111 -> 0010'
? BmpSomeIn( "4", "7" )
? 'BmpSomeIn( "7", "4" ) // Result is .T.: 0111 & 0010 -> 0010'
? BmpSomeIn( "7", "4" )
INKEY(0)
RETURN


//-----------------------
// Hexadecimal operations
//-----------------------
PROCEDURE HexOperat
LOCAL nKey := 1

WHILE nKey <> 0 
	CLS
	? "1. Hex"
	? "2. HexAdd"
	? "3. HexAnd"
	? "4. HexNot"
	? "5. HexOr"
	? "6. HexShl"
	? "7. HexShr"
	? "8. HexXor"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		DoHex()
	CASE nKey == 2
		DoHexAdd()
	CASE nKey == 3
		DoHexAnd()
	CASE nKey == 4
		DoHexNot()
	CASE nKey == 5
		DoHexOr()
	CASE nKey == 6
		DoHexShl()
	CASE nKey == 7
		DoHexShr()
	CASE nKey == 8
		DoHexXor()
	ENDCASE
END

RETURN


//---------
PROCEDURE DoHex
LOCAL hTemp
? 'Hex( "Nonsense4" )     // Result is "EE4"'
? Hex( "Nonsense4" )
? 'Hex( "00008" )     // Result is "8"'
? Hex( "00008" )
? 'Hex( "7" + REPL( "F", 3255) )'
? '                       // Result is "7" + REPLICATE("F", 3255)'
hTemp := Hex( "7" + REPL( "F", 3255) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexAdd
LOCAL hTemp
? 'HexAdd( "4", "8" )     // Result is "C"'
? HexAdd( "4", "8" )
? 'HexAdd( "8", "8" )     // Result is "10"'
? HexAdd( "8", "8" )
? 'HexAdd( "7" + REPL( "F", 3255), "2" )'
? '                       // Result is "8" + REPLICATE("0", 3254) + "1"'
hTemp := HexAdd( "7" + REPL( "F", 3255), "2" )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexAnd
? 'HexAnd( "2134", "8" )  // Result is "0"'
? HexAnd( "2134", "8" )
? 'HexAnd( "2138", "8" )  // Result is "8"'
? HexAnd( "2138", "8" )
? 'HexAnd( "6", "7" + REPL( "F", 3255) )'
? '                       // Result is "6"'
? HexAnd( "6", "7" + REPL( "F", 3255) )
INKEY(0)
RETURN


PROCEDURE DoHexNot
LOCAL hTemp
? 'HexNot( "0" )     // Result is "F": in binary notation NOT 0000 is 1111.'
? HexNot( "0" )
? 'HexNot( "F" )     // Result is "0"'
? HexNot( "F" )
? 'HexNot( "2138" )  // Result is "DEC7"'
? HexNot( "2138" )
? 'HexNot( "7" + REPL( "F", 3255) )'
? '                  // Result is "8" + REPL( "0", 3255 )'
hTemp := HexNot( "7" + REPL( "F", 3255) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexOr
LOCAL hTemp
? 'HexOr( "2134", "8" )  // Result is "213C"'
? HexOr( "2134", "8" )
? 'HexOr( "2138", "8" )  // Result is "2138"'
? HexOr( "2138", "8" )
? 'HexOr( "6", "7" + REPL( "F", 3255) )'
? '                      // Result is "7" + REPL( "F", 3255 )'
hTemp := HexOr( "6", "7" + REPL( "F", 3255) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexShl
LOCAL hTemp
? 'HexShl( "2134", "8" )  // Result is "3400": 0010 0001 0011 0100 ->'
? '                       //                   0011 0100 0000 0000'
? HexShl( "2134", "8" )
? 'HexShl( "2134", "3" )  // Result is "9A0":  0000 1001 1010 0000'
? HexShl( "2134", "3" )
? 'HexShl( "7" + REPL( "F", 3255), 2 )'
? '                       // Result is REPL( "F", 3255 ) + "C":'
? '                       // 0111 1111 .... ..11  -> 1111 11.. .... 1100'
hTemp := HexShl( "7" + REPL( "F", 3255), 2 )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexShr
LOCAL hTemp
? 'HexShr( "2134", "8" )  // Result is "21": 0010 0001 0011 0100 ->'
? '                       //                 0000 0000 0010 0001'
? HexShr( "2134", "8" )
? 'HexShr( "2134", "3" )  // Result is "426": 0000 0100 0010 0110'
? HexShr( "2134", "3" )
? 'HexShr( "7" + REPL( "F", 3255), 2 )'
? '                       // Result is "1" + REPL( "F", 3255 ):'
? '                       // 0111 1111 .... ..11  -> 0001 1111 1... ..11'
hTemp := HexShr( "7" + REPL( "F", 3255), 2 )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoHexXor
LOCAL hTemp
? 'HexXor( "2134", "8" )  // Result is "213C"'
? HexXor( "2134", "8" )
? 'HexXor( "2138", "8" )  // Result is "2130"'
? HexXor( "2138", "8" )
? 'HexXor( "6", "7" + REPL( "F", 3255) )'
? '                       // Result is "7" + REPL( "F", 3254 ) + "9"'
hTemp := HexXor( "6", "7" + REPL( "F", 3255) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


//-----------------------
// Hexadecimal bitmap operations
//-----------------------
PROCEDURE BmpOperat
LOCAL nKey := 1

WHILE nKey <> 0 
	CLS
	? "1. Bmp"
	? "2. BmpAnd"
	? "3. BmpNot"
	? "4. BmpOr"
	? "5. BmpShl"
	? "6. BmpShr"
	? "7. BmpXor"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		DoBmp()
	CASE nKey == 2
		DoBmpAnd()
	CASE nKey == 3
		DoBmpNot()
	CASE nKey == 4
		DoBmpOr()
	CASE nKey == 5
		DoBmpShl()
	CASE nKey == 6
		DoBmpShr()
	CASE nKey == 7
		DoBmpXor()
	ENDCASE
END

RETURN


//---------
PROCEDURE DoBmp
LOCAL hTemp
? 'Bmp( "Nonsense4" )     // Result is "EE4"'
? Bmp( "Nonsense4" )
? 'Bmp( "00008" )     // Result is "00008"'
? Bmp( "00008" )
? 'Bmp( "7" + REPL( "F", 3255) )'
? '                       // Result is "7" + REPLICATE("F", 3255)'
hTemp := Bmp( "7" + REPL( "F", 3255) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoBmpAnd
? 'BmpAnd( "2134", "8" )  // Result is "0000"'
? BmpAnd( "2134", "0008" )
? 'BmpAnd( "2138", "8" )  // Result is "0008"'
? BmpAnd( "2138", "8" )
? 'BmpAnd( "6", "7" + REPL( "F", 3255) )'
? '                       // Result is "6"'
? BmpAnd( "6", "7" + REPL( "F", 3255) )
INKEY(0)
RETURN


PROCEDURE DoBmpNot
LOCAL hTemp
? 'BmpNot( "0" )     // Result is "F": in binary notation NOT 0000 is 1111.'
? BmpNot( "0" )
? 'BmpNot( "2138" )  // Result is "DEC7"'
? BmpNot( "2138" )
? 'BmpNot( "FF7" + REPL( "F", 3253) )'
? '                  // Result is "008" + REPL( "0", 3253 )'
hTemp := BmpNot( "FF7" + REPL( "F", 3253) )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoBmpOr
LOCAL hTemp
? 'BmpOr( "2134", "8" )  // Result is "213C"'
? BmpOr( "2134", "8" )
? 'BmpOr( "2138", "8" )  // Result is "2138"'
? BmpOr( "2138", "8" )
? 'BmpOr( "006", REPL( "F", 3255) + "47" )'
? '                      // Result is "F47"'
? BmpOr( "006", REPL( "F", 3255) + "47" )
INKEY(0)
RETURN


PROCEDURE DoBmpShl
LOCAL hTemp
? 'BmpShl( "2134", "8" )  // Result is "3400": 0010 0001 0011 0100 ->'
? '                       //                   0011 0100 0000 0000'
? BmpShl( "2134", "8" )
? 'BmpShl( "2134", "3" )  // Result is "09A0":  0000 1001 1010 0000'
? BmpShl( "2134", "3" )
? 'BmpShl( "7" + REPL( "F", 3255), 2 )'
? '                       // Result is REPL( "F", 3255 ) + "C":'
? '                       // 0111 1111 .... ..11  -> 1111 11.. .... 1100'
hTemp := BmpShl( "7" + REPL( "F", 3255), 2 )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoBmpShr
LOCAL hTemp
? 'BmpShr( "2134", "8" )  // Result is "0021": 0010 0001 0011 0100 ->'
? '                       //                 0000 0000 0010 0001'
? BmpShr( "2134", "8" )
? 'BmpShr( "2134", "3" )  // Result is "0426": 0000 0100 0010 0110'
? BmpShr( "2134", "3" )
? 'BmpShr( "7" + REPL( "F", 3255), 2 )'
? '                       // Result is "1" + REPL( "F", 3255 ):'
? '                       // 0111 1111 .... ..11  -> 0001 1111 1... ..11'
hTemp := BmpShr( "7" + REPL( "F", 3255), 2 )
? LEFT( hTemp, 20 ), "[...]", RIGHT( hTemp, 20 ), LEN( hTemp )
INKEY(0)
RETURN


PROCEDURE DoBmpXor
LOCAL hTemp
? 'BmpXor( "2134", "8" )  // Result is "213C"'
? BmpXor( "2134", "8" )
? 'BmpXor( "2138", "8" )  // Result is "2130"'
? BmpXor( "2138", "8" )
? 'BmpXor( "006", REPL( "F", 3255) + "47" )'
? '                       // Result is "F41"'
? BmpXor( "006", REPL( "F", 3255) + "47" )
INKEY(0)
RETURN


//------------------------
// Numeric query functions
//------------------------
PROCEDURE NumQuery
LOCAL nKey := 1

WHILE nKey <> 0 
	CLS
	? "1. NumAllIn"
	? "2. NumSomeIn"

	nKey := INKEY(0)
	IF nKey == 27	// Esc
		nKey := 0
	ELSE
		nKey -= 48
	ENDIF

	DO CASE
	CASE nKey == 1
		DoNumAllIn()
	CASE nKey == 2
		DoNumSomeIn()
	ENDCASE
END

RETURN

//--------
PROCEDURE DoNumAllIn
? 'NumAllIn( 4, 8 ) // Result is .F.: 0010 & 0100 -> 0000'
? NumAllIn( 4, 8 )
? 'NumAllIn( 4, 7 ) // Result is .F.: 0010 & 0111 -> 0010'
? NumAllIn( 4, 7 )
? 'NumAllIn( 7, 4 ) // Result is .T.: 0111 & 0010 -> 0010'
? NumAllIn( 7, 4 )
INKEY(0)
RETURN


//---------
PROCEDURE DoNumSomeIn
? 'NumSomeIn( 4, 8 ) // Result is .F.: 0010 & 0100 -> 0000'
? NumSomeIn( 4, 8 )
? 'NumSomeIn( 4, 7 ) // Result is .T.: 0010 & 0111 -> 0010'
? NumSomeIn( 4, 7 )
? 'NumSomeIn( 7, 4 ) // Result is .T.: 0111 & 0010 -> 0010'
? NumSomeIn( 7, 4 )
INKEY(0)
RETURN

PROCEDURE Help
RETURN
